#!/bin/sh
#
# Author: Tony Olech - Elan Digital Systems Limited
# script to process kernel log files $Revision: 1.1 $
# last updated at $Date: 2007/02/12 08:58:47 $
#
if [ -d /var/log/system.old ]; then

	cat /var/log/system.old/kern* | sed -e 's/^[A-Z][a-z][a-z] .. [0-9][0-9]://' -e 's/[-a-zA-Z_0-9]* kernel: //' > /var/log/system.old/KERN
	
	I=0
	while [ $I -lt 99999 ]; do

		I=$((1+I))
		D=`printf "/var/log/system.%03d" $I`

		if [ -d $D ]; then
			continue
		else
			mv /var/log/system.old $D
			echo "cd $D"
			(
			grep 'timed out on ep' $D/KERN
			grep died $D/KERN
			grep Oops $D/KERN
			grep Badness $D/KERN
			grep BUG $D/KERN
			grep ASSERTION $D/KERN
			grep ERROR $D/KERN
			grep WARNING $D/KERN
			grep INFO $D/KERN
			grep invalid $D/KERN
			grep driver $D/KERN | grep 'built at'
			) | sort
			exit 0
		fi
	done
	echo "TOO many log files"

elif [ -r /var/log/.system.sequence ]; then

	I=$(cat /var/log/.system.sequence)
	while [ $I -gt 0 ]; do

		N=$((I-1))
		
		D=`printf "/var/log/system.%03d" $N`

		if [ ! -d $D ]; then
			I=$N
			continue
		elif [ ! -r $D/KERN ]; then
# Dec 14 07:31:37 tony-test kernel: [    0.000000] 0MB HIGHMEM available.

			cat $D/kern* | sed -e 's/^[A-Z][a-z][a-z] .. [0-9][0-9]://' -e 's/[-a-zA-Z_0-9]* kernel: //' > $D/KERN
		fi
		printf "cd /var/log/system.%03d" $N
		echo
		(
			grep 'timed out on ep' $D/KERN
			grep died $D/KERN
			grep Oops $D/KERN
			grep Badness $D/KERN
			grep BUG $D/KERN
			grep ASSERTION $D/KERN
			grep ERROR $D/KERN
			grep WARNING $D/KERN
			grep INFO $D/KERN
			grep invalid $D/KERN
			grep driver $D/KERN | grep 'built at'
		) | sort
		exit 0
	done
	echo "TOO many log files"

else
	I=0
	while [ $I -lt 99999 ]; do

		N=$((1+I))
		
		D=`printf "/var/log/system.%03d" $N`

		if [ -d $D ]; then
			I=$N
			L=$D
			continue
		else
			printf "cd /var/log/system.%03d" $I
			echo
			(
			grep 'timed out on ep' $D/KERN
			grep died $L/KERN
			grep Oops $L/KERN
			grep Badness $L/KERN
			grep BUG $L/KERN
			grep ASSERTION $L/KERN
			grep ERROR $L/KERN
			grep WARNING $L/KERN
			grep INFO $L/KERN
			grep invalid $L/KERN
			grep driver $L/KERN | grep 'built at'
			) | sort
			exit 0
		fi
	done
	echo "TOO many log files"


fi
exit 1
