#!/bin/sh
#

if [ $# -eq 2 ]; then
  if ! ifconfig ath0|head -1|grep -q HWaddr ; then
    echo "INSERT atheros wireless card"
    exit 1
  fi
  OLD=$(ifconfig ath0|head -1|awk '{print $NF}')
  NEW=$2
  if [ x$OLD = x$NEW ]; then
    echo "MAC address already set to $NEW"
  else
    killall dhcpcd
    ifconfig ath0 0.0.0.0 down
    if ! ifconfig ath0 hw ether $NEW ; then
      echo "failed to change MAC address from $OLD to $NEW"
      exit 1
    fi
  fi
elif [ $# -ne 1 ]; then
  echo "usage: $0 NETWORK [MAC-address]"
  exit 1
fi
  case $1 in
  OPEN-04) iwpriv eth1 mode 3   # 11g only
           iwconfig eth1 mode Managed
           iwconfig eth1 channel 4
           iwconfig eth1 essid OPEN-04
           iwconfig eth1 rate 54M
           ifconfig eth1 192.168.99.102 broadcast 192.168.99.255 netmask 255.255.255.0
           ;;
  ELAN)    iwconfig eth0 mode Managed
           iwconfig eth0 channel 7
           iwconfig eth0 essid ELAN-07
           iwconfig eth0 key 1489579799 open
           iwconfig ath0 rate 11M
           dhcpcd eth0
           ;;
  ELAN-07) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 7
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489579799 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  ELAN-10) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 10
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489579799 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  ELAN-13) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 13
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489579799 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  ELAN-01) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 1
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489579799 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  ELAN-04) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 4
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489579799 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  ONEILL)  iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 11
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489892599 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  WARF_ROAD)  iwpriv ath0 mode 2	# 11b only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 2
           iwconfig ath0 essid worldwireless
#          iwpriv ath0 mode 3 ; iwconfig ath0 channel 6 ; iwconfig ath0 essid PrivateNetwork ; iwconfig ath0 rate 54M
           iwconfig ath0 rate 11M
           dhcpcd ath0
           ;;
  SYNOD)   iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 3
           iwconfig ath0 essid tsunami
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  HANTSLUG)   iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 11
           iwconfig ath0 essid HANTSLUG
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  Japan)   iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 6
           iwconfig ath0 essid $1
           iwconfig ath0 key 22EFCB1A20E8C189ED7CF43F58 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  OLECH-01) iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 1
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489878538 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  OLECH)  iwpriv ath0 mode 2	# 11b only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 7
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489878538 open
           iwconfig ath0 rate 11M
           dhcpcd ath0
           ;;
  OLECH-03)  iwpriv ath0 mode 2	# 11b only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 3
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489878538 open
           iwconfig ath0 rate 11M
           dhcpcd ath0
           ;;
  OLECH-11)  iwpriv ath0 mode 3	# 11g only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 11
           iwconfig ath0 essid $1
           iwconfig ath0 key 1489878538 open
           iwconfig ath0 rate 54M
           dhcpcd ath0
           ;;
  NERO)    iwpriv ath0 mode 2	# 11b only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 11
           iwconfig ath0 essid SurfandSip
           iwconfig ath0 rate 11M
           ;;
  MOTORWAY)    iwpriv ath0 mode 2	# 11b only
           iwconfig ath0 mode Managed
           iwconfig ath0 channel 6
           iwconfig ath0 essid BTOpenzone
           iwconfig ath0 rate 11M
           dhcpcd ath0
			# assigned IP = 10.0.80.253 ath0 = 00:0F:EA:91:51:26
           dhcpcd ath0
			# assigned IP = 10.0.80.253 ath0 = 00:0F:EA:91:51:26
			#10.0.80.224 0.0.0.0     255.255.255.224 U  0 0 0 ath0
			#0.0.0.0     10.0.80.225 0.0.0.0         UG 0 0 0 ath0
			#mask = 11100000
			#nameserver 83.146.21.5
			#nameserver 83.146.21.6
			#nameserver 206.14.189.132
			#search surfandsip.net
			#arp who-has 10.0.80.253 (fc:07:01:cb:a8:e1) tell 10.0.80.225
			#arp reply 10.0.80.225 is-at 00:90:4b:25:8d:0d
			#dhcp +router = 10.0.80.225
           ;;
  *)       echo "unrecognised NETWORK '$1'"
           exit 1
           ;;
  esac
  ifconfig ath0
  iwconfig

